// Pilha.H verso usando friend e tipo fixo para inteiro

#include  <stdlib.h>
#include  <iostream.h>
#ifndef _PILHA_H_
#define _PILHA_H_

class Pilha{
private:
	int top;
	tipo_do_elemento local[100];
public:
	friend void push(Pilha& , tipo_do_elemento);
	friend tipo_do_elemento pop(Pilha&);
	friend tipo_do_elemento topo(Pilha);
	friend int vazia(Pilha);
	friend void init(Pilha&);
	friend ostream & operator<< (ostream &, Pilha);

};

void init(Pilha& p)
{
	p.top =-1;
}
void push(Pilha& p, tipo_do_elemento x)
{
	if ( p.top == 99) 
	{
		cerr<< " OVERFLOW ";
		exit(1);
	}
	else  p.local[++(p.top)]=x;
}

tipo_do_elemento pop (Pilha& p)
{
	if( p.top ==-1)
	{
		cerr << " UNDERFLOW ";
		exit(1);
	}
	else
		return (p.local[p.top--]);
}

tipo_do_elemento topo(Pilha p)
{
	if( p.top ==-1)
	{
		cerr << " UNDERFLOW ";
		exit(1);
	}
	else
		return (p.local[p.top]);

}
int vazia(Pilha p)
{
	if( p.top == -1 )
		return 1; // verdade
	else
		return 0;  // falso
}


ostream & operator<<(ostream &out, Pilha p)
{
	int k = p.top;
	out << "top --> ";	
	for(int i= k; i>-1;i--)
	{
		if(i==k)
			out <<"  ";
		else 
		    out << "          ";
		out<< k-i+1 << "o. -> "<< p.local[i]<< endl;
	}
	return out;
}


#endif

